diff --git a/hubs/static/client/app/components/HubConfig/HubConfigPanelGeneral.js b/hubs/static/client/app/components/HubConfig/HubConfigPanelGeneral.js
new file mode 100644
index 0000000..9e5972a
--- /dev/null
+++ b/hubs/static/client/app/components/HubConfig/HubConfigPanelGeneral.js
@@ -0,0 +1,142 @@
+import React from 'react';
+import {
+  defineMessages,
+  FormattedMessage,
+  FormattedHTMLMessage,
+  } from 'react-intl';
+
+
+const messages = defineMessages({
+  title: {
+    id: "hubs.core.config.general.title",
+    defaultMessage: "General Settings",
+  },
+  intro: {
+    id: "hubs.core.config.general.intro",
+    defaultMessage: "Change your global hub parameters here.",
+  },
+  summary: {
+    id: "hubs.core.config.general.summary",
+    defaultMessage: "Summary",
+  },
+  summary_help: {
+    id: "hubs.core.config.general.summary_help",
+    defaultMessage: "This text will be displayed at the top of the hub.",
+  },
+  left_width: {
+    id: "hubs.core.config.general.left_width",
+    defaultMessage: "Left width",
+  },
+  left_width_help: {
+    id: "hubs.core.config.general.left_width_help",
+    defaultMessage: (
+      "Change the proportions of you hub's columns by setting the width of "
+     +"the left column (the right column's width will be {right_width})."
+      ),
+  },
+  visibility: {
+    id: "hubs.core.config.general.visibility",
+    defaultMessage: "Visibility",
+  },
+  visibility_help: {
+    id: "hubs.core.config.general.visibility_help",
+    defaultMessage: (
+      "Public: the hub is visible to anyone.<br />"
+     +"Private: the hub is only visible to members.<br />"
+     +"Preview: some widgets can be made visible to logged-in users only."
+      ),
+  },
+  avatar: {
+    id: "hubs.core.config.general.avatar",
+    defaultMessage: "Avatar",
+  },
+  avatar_help: {
+    id: "hubs.core.config.general.avatar_help",
+    defaultMessage: "An URL to you hub's main image or logo."
+  },
+});
+
+
+export default class GeneralPanel extends React.Component {
+
+  render() {
+    var stillLoading = (typeof this.props.hubConfig.summary === "undefined");
+    var visibilities = this.props.globalConfig.hub_visibility || [];
+    return (
+      <form onSubmit={(e) => {e.preventDefault();}}>
+        <FormattedMessage {...messages.title} tagName="h3" />
+        <FormattedMessage {...messages.intro} tagName="p" />
+        <div className="form-group">
+          <label htmlFor="hub-settings-general-summary">
+            <FormattedMessage {...messages.summary} />
+          </label>
+          <input
+            type="text" className="form-control" name="summary"
+            id="hub-settings-general-summary"
+            disabled={stillLoading}
+            onChange={this.props.handleChange}
+            value={this.props.hubConfig.summary || ""}
+            />
+          <p className="form-text text-muted">
+            <FormattedMessage {...messages.summary_help} />
+          </p>
+        </div>
+        <div className="form-group">
+          <label htmlFor="hub-settings-general-leftwidth">
+            <FormattedMessage {...messages.left_width} />
+          </label>
+          <input
+            type="number" className="form-control" name="left_width"
+            id="hub-settings-general-leftwidth"
+            disabled={stillLoading}
+            min="1" max="11"
+            onChange={this.props.handleChange}
+            value={this.props.hubConfig.left_width || ""}
+            />
+          <p className="form-text text-muted">
+            <FormattedMessage
+              {...messages.left_width_help}
+              values={{right_width: 12 - (this.props.hubConfig.left_width || 8)}}
+              />
+          </p>
+        </div>
+        <div className="form-group">
+          <label htmlFor="hub-settings-general-visibility">
+            <FormattedMessage {...messages.visibility} />
+          </label>
+          <select
+            className="form-control" name="visibility"
+            value={this.props.hubConfig.visibility || ""}
+            onChange={this.props.handleChange}
+            disabled={stillLoading}
+            >
+            {visibilities.map(function(value) {
+              return (
+                <option value={value} key={value}>{value}</option>
+                );
+            })}
+          </select>
+          <p className="form-text text-muted">
+            <FormattedHTMLMessage {...messages.visibility_help} />
+          </p>
+        </div>
+        <div className="form-group">
+          <label htmlFor="hub-settings-general-avatar">
+            <FormattedMessage {...messages.avatar} />
+          </label>
+          <input
+            type="text" className="form-control" name="avatar"
+            id="hub-settings-general-avatar"
+            disabled={stillLoading}
+            onChange={this.props.handleChange}
+            value={this.props.hubConfig.avatar || ""}
+            />
+          <p className="form-text text-muted">
+            <FormattedMessage {...messages.avatar_help} />
+          </p>
+        </div>
+      </form>
+    );
+  }
+
+}
diff --git a/hubs/static/client/app/components/HubConfig/HubConfigPanelNotImpl.js b/hubs/static/client/app/components/HubConfig/HubConfigPanelNotImpl.js
new file mode 100644
index 0000000..7ec90c0
--- /dev/null
+++ b/hubs/static/client/app/components/HubConfig/HubConfigPanelNotImpl.js
@@ -0,0 +1,14 @@
+import React from 'react';
+
+
+export default class NotImplementedPanel extends React.Component {
+
+  render() {
+    return (
+      <div>
+        Not implemented yet.
+      </div>
+    );
+  }
+
+}
diff --git a/hubs/static/client/app/components/HubConfig/HubConfigPanelUser.js b/hubs/static/client/app/components/HubConfig/HubConfigPanelUser.js
new file mode 100644
index 0000000..c516c19
--- /dev/null
+++ b/hubs/static/client/app/components/HubConfig/HubConfigPanelUser.js
@@ -0,0 +1,229 @@
+import React from 'react';
+import {
+  injectIntl,
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+import CompletionInput from '../CompletionInput';
+
+
+const messages = defineMessages({
+  fullname: {
+    id: "hubs.core.config.users.fullname",
+    defaultMessage: "Full name",
+  },
+  username: {
+    id: "hubs.core.config.users.username",
+    defaultMessage: "Username",
+  },
+  change_role: {
+    id: "hubs.core.config.users.change_role",
+    defaultMessage: "Change role",
+  },
+  na: {
+    id: "hubs.core.config.users.na",
+    defaultMessage: "(N/A)",
+  },
+  remove_user: {
+    id: "hubs.core.config.users.remove_user",
+    defaultMessage: "(remove user)",
+  },
+  add_user: {
+    id: "hubs.core.config.users.add_user",
+    defaultMessage: "Add user...",
+  },
+  add: {
+    id: "hubs.core.config.users.add",
+    defaultMessage: "Add",
+  },
+});
+
+
+export default class UserPanel extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      addUser: null,
+      addUserInputContents: "",
+    };
+    this.handleAdd = this.handleAdd.bind(this);
+    this.handleAddChanged = this.handleAddChanged.bind(this);
+    this.handleAddSelected = this.handleAddSelected.bind(this);
+    this.filterSuggestedUsers = this.filterSuggestedUsers.bind(this);
+  }
+
+  handleAdd(e) {
+    e.preventDefault();
+    this.props.handleChange(this.state.addUser, null, this.props.role);
+    this.setState({addUser: null, addUserInputContents: ""});
+  }
+
+  handleAddChanged(e, username) {
+    this.setState({addUserInputContents: username});
+  }
+
+  handleAddSelected(addUser) {
+    this.setState({addUser});
+  }
+
+  filterSuggestedUsers(user) {
+    // Only suggest non-members.
+    return (this.props.users.indexOf(user) === -1);
+  }
+
+  render() {
+    var users = this.props.users.map(function(user) {
+      const locked = (
+        this.props.role === "owner" &&
+        this.props.currentUser.logged_in &&
+        user.username === this.props.currentUser.nickname
+      );
+      return (
+        <UserRow
+          key={user.username}
+          user={user}
+          role={this.props.role}
+          globalConfig={this.props.globalConfig}
+          onChange={this.props.handleChange}
+          locked={locked}
+          />
+        );
+    }.bind(this));
+
+    /*
+    const IntlCompletionInput = injectIntl(function(props) {
+        return (
+          <CompletionInput
+            inputProps={{
+              name: "username",
+              placeholder: props.intl.formatMessage(messages.add_user),
+            }}
+            url={(
+              props.urls.hubConfigSuggestUsers
+              + "?exclude-role=" + props.role
+            )}
+            onChange={this.handleAddInputChange}
+            />
+            );
+    }.bind(this));
+    */
+    const getSuggestionValue = (suggestion) => {
+      return suggestion.username;
+    };
+    const renderSuggestion = (suggestion) => (
+      <span>
+        {suggestion.username}
+        {" "}
+        <small className="text-muted float-right">
+          ({suggestion.fullname})
+        </small>
+      </span>
+    );
+
+    return (
+      <div>
+        <h3>{this.props.tabTitle}</h3>
+        {(this.props.role == "member") &&
+          <div>
+            <p className="text-muted">
+              [Membership requests will be shown here]
+            </p>
+            <hr />
+          </div>
+        }
+        <form
+          className="form-inline mb-3"
+          onSubmit={this.handleAdd}
+          >
+          <div className="form-group">
+            <FormattedMessage {...messages.add_user}>
+              {(message) => (
+                <CompletionInput
+                  inputProps={{
+                    name: "username",
+                    placeholder: message,
+                    value: this.state.addUserInputContents
+                  }}
+                  url={(
+                    this.props.urls.hubConfigSuggestUsers
+                    + "?exclude-role=" + this.props.role
+                  )}
+                  getSuggestionValue={getSuggestionValue}
+                  renderSuggestion={renderSuggestion}
+                  onChange={this.handleAddChanged}
+                  onSelect={this.handleAddSelected}
+                  />
+              )}
+            </FormattedMessage>
+            </div>
+          <button
+            className="btn btn-primary ml-3"
+            disabled={this.props.loading}
+            >
+            <FormattedMessage {...messages.add} />
+          </button>
+        </form>
+        {users.length !== 0 &&
+        <table className="table table-hover table-sm">
+          <thead>
+            <tr>
+              <FormattedMessage {...messages.fullname} tagName="th" />
+              <FormattedMessage {...messages.username} tagName="th" />
+              <FormattedMessage {...messages.change_role} tagName="th" />
+            </tr>
+          </thead>
+          <tbody>
+            {users}
+          </tbody>
+        </table>
+        }
+      </div>
+    );
+  }
+
+}
+
+
+class UserRow extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.handleChange = this.handleChange.bind(this);
+  }
+
+  handleChange(e) {
+    e.preventDefault();
+    this.props.onChange(this.props.user, this.props.role, e.target.value);
+  }
+
+  render() {
+    return (
+      <tr>
+        <td>{this.props.user.fullname}</td>
+        <td>{this.props.user.username}</td>
+        <td>
+          {this.props.locked ?
+            <FormattedMessage {...messages.na} />
+          :
+            <select
+              name={this.props.user.username}
+              value={this.props.role}
+              className="form-control"
+              onChange={this.handleChange}
+              >
+              {this.props.globalConfig.roles.map(function(role) {
+                return (
+                  <option value={role} key={role}>{role}</option>
+                  );
+              })}
+              <FormattedMessage {...messages.remove_user}>
+                {(value) => ( <option value="">{value}</option> )}
+              </FormattedMessage>
+            </select>
+          }
+        </td>
+      </tr>
+    );
+  }
+}
diff --git a/hubs/static/client/app/components/HubConfig/index.js b/hubs/static/client/app/components/HubConfig/index.js
new file mode 100644
index 0000000..8446004
--- /dev/null
+++ b/hubs/static/client/app/components/HubConfig/index.js
@@ -0,0 +1,122 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import { connect } from 'react-redux';
+import {
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+import { saveHub } from '../../core/actions/hub';
+import HubConfigDialog from './HubConfigDialog';
+import "./HubConfig.css";
+
+
+const messages = defineMessages({
+  button: {
+    id: "hubs.core.config.button",
+    defaultMessage: "Hub settings",
+  },
+});
+
+
+class HubConfig extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      config: null,
+      users: null,
+      isDialogOpen: false,
+    };
+    this.handleConfigChange = this.handleConfigChange.bind(this);
+    this.doUserChange = this.doUserChange.bind(this);
+    this.handleOpenClicked = this.handleOpenClicked.bind(this);
+    this.handleCloseClicked = this.handleCloseClicked.bind(this);
+    this.handleSaveClicked = this.handleSaveClicked.bind(this);
+  }
+
+  handleOpenClicked(e) {
+    e.preventDefault();
+    this.setState({
+      isDialogOpen: true,
+      config: this.props.hub.config,
+      users: this.props.hub.users,
+    });
+  }
+
+  handleCloseClicked(e) {
+    e.preventDefault();
+    this.setState({isDialogOpen: false});
+  }
+
+  handleConfigChange(e) {
+    const name = e.target.name, value = e.target.value;
+    this.setState((prevState, props) => {
+      prevState.config[name] = value;
+      return prevState;
+    });
+  }
+
+  doUserChange(user, oldRole, newRole) {
+    this.setState((prevState, props) => {
+      if (oldRole) {
+        // Remove previous role
+        prevState.users[oldRole] = prevState.users[oldRole].filter(
+          (u) => (u.username !== user.username)
+        );
+      }
+      if (newRole) {
+        prevState.users[newRole].push(user);
+      }
+      return {users: prevState.users};
+    });
+  }
+
+  handleSaveClicked(e) {
+    e.preventDefault();
+    this.props.dispatch(saveHub(this.state.config, this.state.users));
+    this.setState({isDialogOpen: false});
+  }
+
+  render() {
+    const openButton = (
+      <button
+        className="open-button btn btn-sm btn-secondary"
+        onClick={this.handleOpenClicked}
+        >
+        <i className="fa fa-cog mr-2" aria-hidden="true"></i>
+        <FormattedMessage {...messages.button} />
+      </button>
+    );
+    return (
+      <div className="HubConfig">
+        {openButton}
+        {this.state.isDialogOpen &&
+          <HubConfigDialog
+            onCloseClicked={this.handleCloseClicked}
+            onSaveClicked={this.handleSaveClicked}
+            hubConfig={this.state.config}
+            users={this.state.users}
+            globalConfig={this.props.globalConfig}
+            onConfigChange={this.handleConfigChange}
+            onUserChange={this.doUserChange}
+            urls={this.props.urls}
+            currentUser={this.props.currentUser}
+            />
+        }
+      </div>
+    );
+  }
+
+}
+
+
+const mapStateToProps = (state) => {
+  return {
+    hub: state.entities.hub,
+    globalConfig: state.globalConfig,
+    urls: state.urls,
+    currentUser: state.currentUser,
+  }
+};
+
+export default connect(mapStateToProps)(HubConfig);
diff --git a/hubs/static/client/app/components/HubHeader.js b/hubs/static/client/app/components/HubHeader.js
new file mode 100644
index 0000000..509c9d1
--- /dev/null
+++ b/hubs/static/client/app/components/HubHeader.js
@@ -0,0 +1,74 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import { connect } from 'react-redux';
+import Spinner from "./Spinner";
+import HubConfig from './HubConfig';
+import EditModeButton from './EditModeButton';
+import "./HubHeader.css";
+
+
+class HubHeader extends React.Component {
+
+  propTypes: {
+    hub: PropTypes.object.isRequired,
+    isLoading: PropTypes.bool,
+    currentUser: PropTypes.object,
+  }
+
+  render() {
+    return (
+      <div className="HubHeader">
+        { this.props.isLoading &&
+          <Spinner />
+        }
+        { this.props.hub.name &&
+          <div className="row">
+            <div className={`col-md-${this.props.hub.config.left_width}`}>
+              { this.props.hub.user_hub ?
+                <div>
+                  <img
+                    className="avatar"
+                    src={this.props.hub.config.avatar}
+                    />
+                  <h2 className="user mb-0">
+                    {this.props.hub.name}
+                  </h2>
+                  <h5 className="mt-1 mb-1">
+                    {this.props.hub.config.summary}
+                  </h5>
+                  <div className="clearfix"></div>
+                </div>
+              :
+                <div>
+                  <h2 className="team">
+                    {this.props.hub.name}
+                  </h2>
+                  <h5 className="mt-1 mb-1">
+                    {this.props.hub.config.summary}
+                  </h5>
+                </div>
+              }
+            </div>
+            { this.props.currentUser.can_config_hub &&
+              <div className={`col-md-${this.props.hub.config.right_width} text-center align-self-end`}>
+                <HubConfig />
+                <EditModeButton />
+              </div>
+            }
+          </div>
+        }
+      </div>
+    );
+  }
+}
+
+
+const mapStateToProps = (state) => {
+  return {
+    hub: state.entities.hub,
+    isLoading: state.entities.hub.isLoading,
+    currentUser: state.currentUser,
+  }
+};
+
+export default connect(mapStateToProps)(HubHeader);
diff --git a/hubs/static/client/app/components/HubPage.js b/hubs/static/client/app/components/HubPage.js
new file mode 100644
index 0000000..57ce5d0
--- /dev/null
+++ b/hubs/static/client/app/components/HubPage.js
@@ -0,0 +1,37 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import { connect } from 'react-redux';
+import {
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+import PageStructure from './PageStructure';
+import WidgetsArea from './WidgetsArea';
+import HubHeader from './HubHeader';
+import { fetchHub } from '../core/actions/hub';
+import "./HubPage.css";
+
+
+class HubPage extends React.Component {
+
+  componentDidMount() {
+    this.props.dispatch(fetchHub());
+  }
+
+  render() {
+    return (
+      <PageStructure
+        cssClass="HubPage"
+        header={
+          <HubHeader />
+        }
+        content={
+          <WidgetsArea />
+        }
+        />
+    );
+  }
+}
+
+
+export default connect()(HubPage);
diff --git a/hubs/static/client/app/components/LeftMenu.js b/hubs/static/client/app/components/LeftMenu.js
new file mode 100644
index 0000000..066cf6d
--- /dev/null
+++ b/hubs/static/client/app/components/LeftMenu.js
@@ -0,0 +1,76 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import { connect } from 'react-redux';
+import "./LeftMenu.css";
+
+
+class LeftMenu extends React.Component {
+
+  propTypes: {
+    menu: PropTypes.array,
+  }
+  defaultProps: {
+    menu: [],
+  }
+
+  render() {
+    return (
+      <div className="LeftMenu">
+        <ul
+          className="nav nav-pills flex-lg-column mb-3 rounded"
+          role="navigation"
+          >
+          {this.props.menu.map((entry) => (
+            <LeftMenuEntry
+              key={entry.url}
+              {...entry}
+              />
+            ))
+          }
+        </ul>
+      </div>
+    );
+  }
+}
+
+const mapStateToProps = (state) => {
+  return {
+    menu: state.ui.leftMenu,
+  }
+};
+
+export default connect(mapStateToProps)(LeftMenu);
+
+
+class LeftMenuEntry extends React.Component {
+
+  propTypes: {
+    url: PropTypes.string.isRequired,
+    icon: PropTypes.string.isRequired,
+    text: PropTypes.string.isRequired,
+    cssClass: PropTypes.string,
+  }
+  defaultProps: {
+    cssClass: null,
+  }
+
+  render() {
+    const isActive = window.location.pathname.indexOf(this.props.url) !== -1;
+    let cssClass = "nav-link";
+    if (isActive) {
+      cssClass += " active";
+    }
+    if (this.props.cssClass) {
+      cssClass += " " + this.props.cssClass;
+    }
+    return (
+      <li className="nav-item">
+        <a className={cssClass} href={this.props.url}>
+          <i className={`fa fa-${this.props.icon} mr-2`}
+             aria-hidden="true"></i>
+          {this.props.text}
+        </a>
+      </li>
+    );
+  }
+}
diff --git a/hubs/static/client/app/components/Modal.js b/hubs/static/client/app/components/Modal.js
new file mode 100644
index 0000000..5a468f1
--- /dev/null
+++ b/hubs/static/client/app/components/Modal.js
@@ -0,0 +1,69 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+
+
+export default class Modal extends React.Component {
+
+  propTypes: {
+    isLarge: PropTypes.bool,
+    onCloseClicked: PropTypes.func,
+    title: PropTypes.node,
+    footer: PropTypes.node,
+    cssClass: PropTypes.string,
+  }
+  defaultProps: {
+    isLarge: false,
+  }
+
+  constructor(props) {
+    super(props);
+    this.handleCloseClicked = this.handleCloseClicked.bind(this);
+  }
+
+  handleCloseClicked(e) {
+    if (this.props.onCloseClicked) {
+      this.props.onCloseClicked(e);
+    }
+  }
+
+  stopPropagation(e) {
+    e.stopPropagation();
+  }
+
+  render() {
+    return (
+      <div className={this.props.cssClass}>
+        <div className="modal-backdrop show"></div>
+        <div
+          className="modal" style={{display: "block"}}
+          onClick={this.handleCloseClicked}
+          >
+          <div
+            className={"modal-dialog" + (this.props.isLarge ? " modal-lg" : "")}
+            onClick={this.stopPropagation}
+            >
+            <div className="modal-content">
+                <div className="modal-header">
+                  <h5 className="modal-title">
+                    {this.props.title}
+                  </h5>
+                  <button
+                    type="button" className="close" aria-label="Close"
+                    onClick={this.handleCloseClicked}
+                    >
+                    <span aria-hidden="true">&times;</span>
+                  </button>
+                </div>
+                <div className="modal-body">
+                  {this.props.children}
+                </div>
+                <div className="modal-footer">
+                  {this.props.footer}
+                </div>
+            </div>
+          </div>
+        </div>
+      </div>
+    );
+  }
+}
diff --git a/hubs/static/client/app/components/NotifIcon.js b/hubs/static/client/app/components/NotifIcon.js
new file mode 100644
index 0000000..9330e99
--- /dev/null
+++ b/hubs/static/client/app/components/NotifIcon.js
@@ -0,0 +1,55 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import { connect } from 'react-redux';
+
+
+class NotifIcon extends React.PureComponent {
+
+  constructor(props) {
+    super(props);
+    this.notifTimeout = null;
+    this.changeNotifyIcon = this.changeNotifyIcon.bind(this);
+  }
+
+  componentDidUpdate(prevProps, prevState) {
+    // Icon to red on disconnect, icon to green on reconnect.
+    if (!prevProps.sseConnected && this.props.sseConnected) {
+      // Connected
+      this.changeNotifyIcon("green");
+    } else if (prevProps.sseConnected && !this.props.sseConnected) {
+      // Disconnected
+      this.changeNotifyIcon("red");
+    }
+  }
+
+  changeNotifyIcon(color) {
+    // Set the notify icon for 5s
+    if (color == "green") {
+      color = "#33ff00";
+    } else if (color == "red") {
+      color = "#eb361e";
+    }
+    window.Notificon(color);
+    if (this.notifTimeout) { clearTimeout(this.notifTimeout); }
+    this.notifTimeout = setTimeout(() => (window.Notificon()), 5000);
+  }
+
+  render() {
+    return null;
+  }
+}
+NotifIcon.propTypes = {
+  sseConnected: PropTypes.bool,
+}
+NotifIcon.defaultProps = {
+  sseConnected: false,
+}
+
+
+const mapStateToProps = (state) => {
+  return {
+    sseConnected: state.sse.connected,
+  }
+};
+
+export default connect(mapStateToProps)(NotifIcon);
diff --git a/hubs/static/client/app/components/PageStructure.js b/hubs/static/client/app/components/PageStructure.js
new file mode 100644
index 0000000..ee6cd14
--- /dev/null
+++ b/hubs/static/client/app/components/PageStructure.js
@@ -0,0 +1,34 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import FlashMessages from './FlashMessages';
+import LeftMenu from './LeftMenu';
+
+
+export default class PageStructure extends React.Component {
+
+  render() {
+    return (
+      <div className={this.props.cssClass}>
+        <header>
+          <FlashMessages />
+          <div className="row">
+            <div className="col-lg-2">
+              <LeftMenu />
+            </div>
+            <div className="col-lg-10">
+              {this.props.header}
+            </div>
+          </div>
+        </header>
+
+        <div className="container-fluid">
+          <div className="row">
+            <div className="offset-lg-2 col-lg-10 px-0">
+              {this.props.content}
+            </div>
+          </div>
+        </div>
+      </div>
+    );
+  }
+}
diff --git a/hubs/static/client/app/components/SSESource.js b/hubs/static/client/app/components/SSESource.js
new file mode 100644
index 0000000..930a38c
--- /dev/null
+++ b/hubs/static/client/app/components/SSESource.js
@@ -0,0 +1,82 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import { connect } from 'react-redux';
+import ReconnectingEventSource from "reconnecting-eventsource";
+import {
+  sseEvent,
+  sseConnected,
+  sseDisconnected
+} from "../core/actions/sse";
+
+
+const MESSAGE_TYPES = [
+  "hubs:widget-updated",
+  "hubs:new-notification",
+];
+
+
+class SSESource extends React.PureComponent {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      isEnabled: true,
+    }
+    this.source = null;
+    this.notifTimeout = null;
+    this.setupSource = this.setupSource.bind(this);
+  }
+
+  componentDidMount() {
+    if (!this.props.url || !window.EventSource) {
+      // Auto-update is disabled.
+      this.setState({isEnabled: false});
+    } else {
+      this.setupSource();
+    }
+  }
+
+  componentWillUnmount() {
+    if (this.source) {
+      this.source.close();
+    }
+    //window.removeEventListener("beforeunload", this.tearDownSSESource);
+  }
+
+  setupSource() {
+    this.source = new ReconnectingEventSource(this.props.url),
+    MESSAGE_TYPES.forEach((msgType) => {
+      this.source.addEventListener(msgType, (e) => {
+        this.props.dispatch(sseEvent(msgType, JSON.parse(e.data)));
+      });
+    });
+    this.source.onopen = () => (
+      this.props.dispatch(sseConnected(this.source))
+    );
+    this.source.onerror = () => (
+      this.props.dispatch(sseDisconnected(this.source))
+    );
+    // This is necessary to avoid the error message being displayed right
+    // before the user changes page.
+    // Pretty much like: https://bugzilla.mozilla.org/show_bug.cgi?id=833462
+    window.addEventListener("beforeunload", () => {
+      this.source.onerror = () => (null);
+    });
+  }
+
+  render() {
+    return null;
+  }
+}
+SSESource.propTypes = {
+  url: PropTypes.string.isRequired,
+}
+
+
+const mapStateToProps = (state) => {
+  return {
+    url: state.urls.sse,
+  }
+};
+
+export default connect(mapStateToProps)(SSESource);
diff --git a/hubs/static/client/app/components/SimpleWidget.js b/hubs/static/client/app/components/SimpleWidget.js
new file mode 100644
index 0000000..9a62fe5
--- /dev/null
+++ b/hubs/static/client/app/components/SimpleWidget.js
@@ -0,0 +1,86 @@
+import React from 'react';
+import {
+  widgetDidUpdate,
+  widgetWillUpdate
+  } from "../core/actions/widget";
+import { backendCall } from "../core/utils";
+import SimpleWidgetConfig from './SimpleWidgetConfig';
+import WidgetChrome from './WidgetChrome';
+
+
+export default class SimpleWidget extends React.PureComponent {
+
+  propTypes: {
+    widget: PropTypes.object.isRequired,
+    editMode: PropTypes.bool,
+    needsUpdate: PropTypes.bool,
+  }
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      isLoading: false,
+      contents: "",
+    };
+  }
+
+  componentDidMount() {
+    if (!this.props.editMode) {
+      this.loadFromServer();
+    }
+  }
+
+  componentDidUpdate(prevProps, prevState) {
+    if (this.props.needsUpdate && !this.props.editMode && !this.state.isLoading) {
+      this.loadFromServer();
+    }
+  }
+
+  loadFromServer() {
+    this.props.dispatch(widgetWillUpdate(this.props.widget.idx));
+    this.setState({ isLoading: true });
+    let url = this.props.widget.contentUrl;
+    if (this.props.editMode) {
+      url += "?edit=1";
+    }
+    return backendCall(url).catch(
+      (error) => (
+        `<div class="text-danger">Cannot display this widget: ${error.message}</div>`
+      )
+    ).then(
+      (contents) => {
+        this.setState({
+          isLoading: false, contents
+        }, () => (
+          this.props.dispatch(widgetDidUpdate(this.props.widget.idx))
+        ));
+      }
+    );
+  }
+
+  render() {
+    if (this.props.widget.hiddenIfEmpty) {
+      if (
+        this.state.isLoading ||
+        !this.props.editMode && (
+          !this.state.contents || !this.state.contents.trim()
+        )
+      ) {
+        // Hide when loading and when the contents is empty in view mode.
+        return null;
+      }
+    }
+    return (
+      <WidgetChrome
+        widget={this.props.widget}
+        editMode={this.props.editMode}
+        >
+        { this.state.isLoading &&
+          <div className="text-muted">Loading...</div>
+          ||
+          <div dangerouslySetInnerHTML={{__html: this.state.contents}} />
+        }
+      </WidgetChrome>
+    );
+  }
+}
diff --git a/hubs/static/client/app/components/SimpleWidgetConfig.js b/hubs/static/client/app/components/SimpleWidgetConfig.js
new file mode 100644
index 0000000..f323b52
--- /dev/null
+++ b/hubs/static/client/app/components/SimpleWidgetConfig.js
@@ -0,0 +1,42 @@
+import React from 'react';
+
+
+export default class SimpleWidgetConfig extends React.Component {
+
+  propTypes: {
+    widget: PropTypes.object.isRequired,
+    values: PropTypes.object.isRequired,
+    setConfig: PropTypes.func.isRequired,
+  }
+
+  render() {
+    let fields = this.props.widget.params.map((field) => {
+      return (
+        <fieldset className="form-group" key={field.name}>
+          <strong>{field.label}</strong>
+          <input
+            className="form-control"
+            type="text"
+            value={this.props.values[field.name] || ""}
+            name={field.name}
+            onChange={(e) => {
+              this.props.setConfig(e.target.name, e.target.value)
+            }}
+            />
+          { field.help &&
+            <small className="text-muted">{field.help}</small>
+          }
+        </fieldset>
+      );
+    });
+    return (
+      <div>
+        { fields.length === 0 ?
+          <p>Nothing to configure</p>
+          :
+          fields
+        }
+      </div>
+    );
+  }
+}
